Index: /greenstone3/trunk/web/WEB-INF/web.xml
===================================================================
--- /greenstone3/trunk/web/WEB-INF/web.xml	(revision 15066)
+++ /greenstone3/trunk/web/WEB-INF/web.xml	(revision 15067)
@@ -9,9 +9,14 @@
 -->
 <web-app>
+
+
   <!-- General description of your web application -->
-  <display-name>Flax</display-name>
+  
+  <display-name>GSDL3</display-name>
   <description>
-    Flaxible Language Acquisition Project version 1.0
-  </description>  
+    Greenstone digital library version 3.
+  </description>
+  
+  
   <!-- Context initialization parameters that define shared
   String constants used within your application, which
@@ -40,4 +45,5 @@
   </context-param>
   
+
   <!-- Servlet definitions for the servlets that make up
   your web application, including initialization
@@ -64,19 +70,26 @@
   You can define any number of servlets, including zero.
   -->
-  <servlet>
-    <servlet-name>flax</servlet-name>
-    <description></description>
-    <servlet-class>org.greenstone.gsdl3.flax.FlaxServlet</servlet-class>
+
+  <servlet>
+    <servlet-name>tester</servlet-name>
+    <description>a test servlet</description>
+    <servlet-class>TestServlet</servlet-class>
+  </servlet>
+  
+  <servlet>
+    <servlet-name>library</servlet-name>
+    <description>standard gsdl3 library program: uses localsite and the default interface</description>
+    <servlet-class>org.greenstone.gsdl3.LibraryServlet</servlet-class>
     <init-param>
       <param-name>library_name</param-name>
-      <param-value>flax</param-value>
+      <param-value>library</param-value>
     </init-param>
     <init-param>
       <param-name>site_name</param-name>
-      <param-value>flax</param-value>
+      <param-value>localsite</param-value>
     </init-param>
     <init-param>
       <param-name>interface_name</param-name>
-      <param-value>flax</param-value>
+      <param-value>classic</param-value>
     </init-param>
     <init-param>
@@ -88,5 +101,99 @@
       <param-value>1800</param-value>
     </init-param>
-  </servlet>  
+  </servlet>
+  <servlet>
+    <servlet-name>gateway</servlet-name>
+    <description>gsdl3 library based on gateway site and default interface. It uses SOAP to talk to localsite</description>
+    <servlet-class>org.greenstone.gsdl3.LibraryServlet</servlet-class>
+    <init-param>
+      <param-name>library_name</param-name>
+      <param-value>gateway</param-value>
+    </init-param>
+    <init-param>
+      <param-name>site_name</param-name>
+      <param-value>gateway</param-value>
+    </init-param>
+    <init-param>
+      <param-name>interface_name</param-name>
+      <param-value>default</param-value>
+    </init-param>
+    <init-param>
+      <param-name>default_lang</param-name>
+      <param-value>en</param-value>
+    </init-param>
+  </servlet>
+  
+  <servlet>
+    <servlet-name>classic-library</servlet-name>
+    <description>Greenstone 2 lookalike library program: uses localsite with the classic interface</description>
+    <servlet-class>org.greenstone.gsdl3.LibraryServlet</servlet-class>
+    <init-param>
+      <param-name>library_name</param-name>
+      <param-value>classic</param-value>
+    </init-param>
+    <init-param>
+      <param-name>site_name</param-name>
+      <param-value>localsite</param-value>
+    </init-param>
+    <init-param>
+      <param-name>interface_name</param-name>
+      <param-value>classic</param-value>
+    </init-param>
+    <init-param>
+      <param-name>default_lang</param-name>
+      <param-value>en</param-value>
+    </init-param>
+    <init-param>
+      <param-name>params_class</param-name>
+      <param-value>NZDLParams</param-value>
+    </init-param>
+  </servlet>
+
+  <!-- axis servlets -->
+  <servlet>
+    <servlet-name>AxisServlet</servlet-name>
+    <display-name>Apache-Axis Servlet</display-name>
+    <servlet-class>
+        org.apache.axis.transport.http.AxisServlet
+    </servlet-class>
+  </servlet>
+
+  <servlet>
+    <servlet-name>AdminServlet</servlet-name>
+    <display-name>Axis Admin Servlet</display-name>
+    <servlet-class>
+        org.apache.axis.transport.http.AdminServlet
+    </servlet-class>
+    <load-on-startup>100</load-on-startup>
+  </servlet>
+
+  <servlet>
+    <servlet-name>SOAPMonitorService</servlet-name>
+    <display-name>SOAPMonitorService</display-name>
+    <servlet-class>
+        org.apache.axis.monitor.SOAPMonitorService
+    </servlet-class>
+    <init-param>
+      <param-name>SOAPMonitorPort</param-name>
+      <param-value>5001</param-value>
+    </init-param>
+    <load-on-startup>100</load-on-startup>
+  </servlet>
+<servlet>
+         <servlet-name>oaiserver</servlet-name>
+	 <description>an oai servlet</description>
+         <servlet-class>org.greenstone.gsdl3.OAIServer</servlet-class>
+         <init-param>
+           <param-name>default_lang</param-name>
+           <param-value>en</param-value>
+         </init-param>
+         <init-param>
+           <param-name>site_name</param-name>
+           <!-- More than one site name can be specified using the comma separation style: localsite1,localsite2 -->
+           <param-value>localsite</param-value>
+         </init-param>
+</servlet>
+<!--
+-->  
     <!-- Define mappings that are used by the servlet container to
          translate a particular request URI (context-relative) to a
@@ -108,60 +215,77 @@
          servlet, if you wish to.
     -->
+    <!--
+    
+    <servlet-mapping>
+      <servlet-name>controller</servlet-name>
+      <url-pattern>*.do</url-pattern>
+    </servlet-mapping>
+
+    <servlet-mapping>
+      <servlet-name>graph</servlet-name>
+      <url-pattern>/graph</url-pattern>
+    </servlet-mapping>
+    -->
+    
+
 <servlet-mapping>
-      <servlet-name>flax</servlet-name>
-      <url-pattern>/flax</url-pattern>
+      <servlet-name>oaiserver</servlet-name>
+      <url-pattern>/oaiserver</url-pattern>
 </servlet-mapping>
 
-<!--********servlets/mappings used by the Flax web service (especially the first one - copied from packages/axis/webapps/axis/WEB-INF/web.xml ****-->
-  <servlet>
-    <servlet-name>AxisServlet</servlet-name>
-    <display-name>Apache-Axis Servlet</display-name>
-    <servlet-class>
-        org.apache.axis.transport.http.AxisServlet
-    </servlet-class>
-  </servlet>
-  <servlet>
-    <servlet-name>AdminServlet</servlet-name>
-    <display-name>Axis Admin Servlet</display-name>
-    <servlet-class>
-        org.apache.axis.transport.http.AdminServlet
-    </servlet-class>
-    <load-on-startup>100</load-on-startup>
-  </servlet>
-  <servlet>
-    <servlet-name>SOAPMonitorService</servlet-name>
-    <display-name>SOAPMonitorService</display-name>
-    <servlet-class>
-        org.apache.axis.monitor.SOAPMonitorService
-    </servlet-class>
-    <init-param>
-      <param-name>SOAPMonitorPort</param-name>
-      <param-value>5001</param-value>
-    </init-param>
-    <load-on-startup>100</load-on-startup>
-  </servlet>
+  <servlet-mapping>
+    <servlet-name>tester</servlet-name>
+    <url-pattern>/testing</url-pattern>
+  </servlet-mapping>
+  
+  <servlet-mapping>
+    <servlet-name>library</servlet-name>
+    <url-pattern>/library</url-pattern>
+  </servlet-mapping>
+  
+  <servlet-mapping>
+    <servlet-name>gateway</servlet-name>
+    <url-pattern>/gateway</url-pattern>
+  </servlet-mapping>
+  
+  <servlet-mapping>
+    <servlet-name>classic-library</servlet-name>
+    <url-pattern>/classic</url-pattern>
+  </servlet-mapping>
+  
+  <!-- axis mappings -->
   <servlet-mapping>
     <servlet-name>AxisServlet</servlet-name>
     <url-pattern>/servlet/AxisServlet</url-pattern>
   </servlet-mapping>
+
   <servlet-mapping>
     <servlet-name>AxisServlet</servlet-name>
     <url-pattern>*.jws</url-pattern>
   </servlet-mapping>
+
   <servlet-mapping>
     <servlet-name>AxisServlet</servlet-name>
     <url-pattern>/services/*</url-pattern>
   </servlet-mapping>
+
+  <!-- uncomment this if you want to use the SOAPMonitorService. You will also 
+  need to copy the SOAPMonitorApplet*.class files from 
+  gsdl3/comms/soap/axis/web/WEB-INF/classes to the gsdl3/web directory. See the 
+  comms/soap/axis/docs/install.html Appendix for details about how to use this -->
+  <!--
   <servlet-mapping>
     <servlet-name>SOAPMonitorService</servlet-name>
     <url-pattern>/SOAPMonitor</url-pattern>
   </servlet-mapping>
-  
-  <servlet-mapping>
-    <servlet-name>AxisServlet</servlet-name>
-    <url-pattern>/flax/*</url-pattern>
-  </servlet-mapping>
-  <!--********end of Servlet mappings used by Flax web service ***************************-->
-  
+  -->
+  <!-- uncomment this if you want the admin servlet -->
+  <!--
+  <servlet-mapping>
+    <servlet-name>AdminServlet</servlet-name>
+    <url-pattern>/servlet/AdminServlet</url-pattern>
+  </servlet-mapping>
+  -->
+
   <!-- Define the default session timeout for your application,
   in minutes.  From a servlet or JSP page, you can modify