Index: /release-kits/lirk3/bin/lirk3
===================================================================
--- /release-kits/lirk3/bin/lirk3	(revision 15096)
+++ /release-kits/lirk3/bin/lirk3	(revision 15097)
@@ -50,5 +50,5 @@
 
 	elif [ "$1" == "-cp" ]; then
-		echo $LIRK3_CLASSPATH
+		echo $CLASSPATH
 		exit
 
Index: /release-kits/lirk3/installer/antinstall-config.xml
===================================================================
--- /release-kits/lirk3/installer/antinstall-config.xml	(revision 15096)
+++ /release-kits/lirk3/installer/antinstall-config.xml	(revision 15097)
@@ -1,3 +1,3 @@
-<?xml version="1.0"?>
+<?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE installer PUBLIC "-//tp23 //DTD Ant Installer Config//EN" "http://antinstaller.sf.net/dtd/antinstall-config-0.8.dtd">
 <installer
@@ -15,5 +15,5 @@
 			type="input"
 			name="intro"
-			displayText="Welcome to the Greenstone3 installer">
+			displayText="ç»¿å®ç³èœ¯ä»¶">
 	</page>
 
@@ -43,5 +43,5 @@
 	<page type="input" name="tomcatports" displayText="Tomcat Ports">
 
-		<comment displayText="Please select the ports which the web server (Apache Tomcat) will use  will use. It is usually safe to accept the defaults by just clicking Next. The exception is when you are running other services on these ports - if this is the case, select some free ports and click Next."/>
+		<comment name="tomcatportsdescription" displayText="Please select the ports which the web server (Apache Tomcat) will use  will use. It is usually safe to accept the defaults by just clicking Next. The exception is when you are running other services on these ports - if this is the case, select some free ports and click Next."/>
 
 		<text property="tomcat.port" defaultValue="8080" displayText="Tomcat Port"/>
@@ -55,4 +55,5 @@
 			displayText="Components to install">
 		<comment
+				name="choosecomponents"
 				displayText="Choose the components you want to install"
 				bold="true"/>
Index: /release-kits/lirk3/installer/cp/resources/LanguagePack_en_NZ.properties
===================================================================
--- /release-kits/lirk3/installer/cp/resources/LanguagePack_en_NZ.properties	(revision 15097)
+++ /release-kits/lirk3/installer/cp/resources/LanguagePack_en_NZ.properties	(revision 15097)
@@ -0,0 +1,29 @@
+### Ant Installer - language pack auto generated on Wed Mar 12 16:17:54 NZDT 2008
+
+finishButtonText = Install
+
+
+## Text from Page:intro
+page.intro.displayText = \u7EFF\u5B9D\u77F3\u8F6F\u4EF6
+
+## Text from Page:license
+page.license.displayText = License conditions
+
+## Text from Page:destination
+page.destination.displayText = Install Destination
+installDir.displayText = Select an installation directory
+
+## Text from Page:tomcatports
+page.tomcatports.displayText = Tomcat Ports
+tomcatportsdescription.displayText = Please select the ports which the web server (Apache Tomcat) will use  will use. It is usually safe to accept the defaults by just clicking Next. The exception is when you are running other services on these ports - if this is the case, select some free ports and click Next.
+tomcat.port.displayText = Tomcat Port
+tomcat.shutdown.port.displayText = Tomcat Shutdown Port
+
+## Text from Page:selector
+page.selector.displayText = Components to install
+choosecomponents.displayText = Choose the components you want to install
+default.displayText = Core components
+tgsrc.displayText = Source code
+
+## Text from Page:progress
+page.progress.displayText = Installation progress
Index: /release-kits/lirk3/installer/cp/resources/LanguagePack_zh_CN.properties
===================================================================
--- /release-kits/lirk3/installer/cp/resources/LanguagePack_zh_CN.properties	(revision 15097)
+++ /release-kits/lirk3/installer/cp/resources/LanguagePack_zh_CN.properties	(revision 15097)
@@ -0,0 +1,29 @@
+### Ant Installer - language pack auto generated on Wed Mar 12 13:57:47 NZDT 2008
+
+finishButtonText =  ç»¿å®ç³èœ¯ä»¶
+
+
+## Text from Page:intro
+page.intro.displayText = ç»¿å®ç³èœ¯ä»¶
+
+## Text from Page:license
+page.license.displayText = License conditions
+
+## Text from Page:destination
+page.destination.displayText = Install Destination
+installDir.displayText = Select an installation directory
+
+## Text from Page:tomcatports
+page.tomcatports.displayText = Tomcat Ports
+comment.2.displayText = Please select the ports which the web server (Apache Tomcat) will use  will use. It is usually safe to accept the defaults by just clicking Next. The exception is when you are running other services on these ports - if this is the case, select some free ports and click Next.
+tomcat.port.displayText = Tomcat Port
+tomcat.shutdown.port.displayText = Tomcat Shutdown Port
+
+## Text from Page:selector
+page.selector.displayText = Components to install
+comment.5.displayText = Choose the components you want to install
+default.displayText = Core components
+tgsrc.displayText = Source code
+
+## Text from Page:progress
+page.progress.displayText = Installation progress
Index: /release-kits/lirk3/installer/createLanguagePack.sh
===================================================================
--- /release-kits/lirk3/installer/createLanguagePack.sh	(revision 15097)
+++ /release-kits/lirk3/installer/createLanguagePack.sh	(revision 15097)
@@ -0,0 +1,37 @@
+#!/bin/sh
+
+# This script creates properties files stubs from the antinstall-config.xml file
+#
+# it only works if attributes are placed on separate lines
+
+dir=`expr  match "$0" '\(.*\)createResourceStub.sh'`
+#  if it we did not call ./  change to the directory we called
+if [ "$dir" != "./" ] ; then
+   if [ "$dir" != "" ] ;  then
+      cd "$dir" ;
+   fi
+fi
+
+if [ "$ANT_INSTALL_HOME" == "" ] ; then 
+  export ANT_INSTALL_HOME=../../../..
+fi
+
+if [ ! -f $ANT_INSTALL_HOME/lib/ant-installer.jar ] ; then 
+  echo "set ANT_INSTALL_HOME"
+  exit 1;
+fi
+
+if [ "$JAVA_HOME" = "" ] ; then
+	echo set JAVA_HOME;
+	exit 1;
+fi
+
+
+CLASSPATH=$ANT_INSTALL_HOME/lib/xercesImpl.jar:$ANT_INSTALL_HOME/lib/xml-apis.jar:$ANT_INSTALL_HOME/lib/ant-installer.jar:$ANT_INSTALL_HOME/lib/ant-installer-ext.jar
+CLASSPATH=$CLASSPATH:$ANT_INSTALL_HOME/antlib/ant.jar:$ANT_INSTALL_HOME/antlib/ant-launcher.jar
+CLASSPATH=$CLASSPATH:$ANT_INSTALL_HOME/lib/jgoodies-edited-1_2_2.jar
+CLASSPATH=$CLASSPATH:./cp
+
+COMMAND=$JAVA_HOME/bin/java
+
+$COMMAND -classpath $CLASSPATH  org.tp23.antinstaller.util.CreateLanguagePack